<!-- main view -->

<template>
  <div class="editview">
    <!-- toolbar -->
    <v-toolbar :dense='true'>
      <v-toolbar-items>
        <v-btn icon @click="togglePlay"><v-icon>{{ playIcon }}</v-icon></v-btn>
        <span class="sep">|</span>
      </v-toolbar-items>  
      <!-- edit mode toolbar -->
      <transition name="fadeup">
        <v-toolbar-items v-show="!viewData.running" ref="tbtrans">
          <v-btn icon><v-icon>mdi-folder-open</v-icon></v-btn>
          <v-btn icon><v-icon>mdi-content-save</v-icon></v-btn>
          <span class="sep">|</span>
          <v-btn icon @click="zoomIn()"><v-icon>mdi-magnify-plus</v-icon></v-btn>    
          <v-btn icon @click="zoomReset()"><v-icon>mdi-magnify-scan</v-icon></v-btn>    
          <v-btn icon @click="zoomOut()"><v-icon>mdi-magnify-minus</v-icon></v-btn>    
          <span class="sep">|</span>
          <v-btn icon :disabled="selCount===0" @click="viewData.deleteSelected()"><v-icon>mdi-delete</v-icon></v-btn>
          <v-btn icon :disabled="selCount===0" @click="viewData.cut()"><v-icon>mdi-content-cut</v-icon></v-btn>
          <v-btn icon :disabled="selCount===0" @click="viewData.copy()"><v-icon>mdi-content-copy</v-icon></v-btn>
          <v-btn icon><v-icon @click="viewData.paste()">mdi-content-paste</v-icon></v-btn>
          <span class="sep">|</span>
          <v-btn icon :disabled='!viewData.canUndo' @click="viewData.undo()"><v-icon>mdi-undo</v-icon></v-btn>
          <v-btn icon :disabled='!viewData.canRedo' @click="viewData.redo()"><v-icon>mdi-redo</v-icon></v-btn>
          <span class="sep">|</span>
          <v-btn icon :disabled="selCount<2" @click="viewData.alignSelectedToLeft()"><v-icon>mdi-align-horizontal-left</v-icon></v-btn>    
          <v-btn icon :disabled="selCount<2" @click="viewData.alignSelectedToCenter()"><v-icon>mdi-align-horizontal-center</v-icon></v-btn>    
          <v-btn icon :disabled="selCount<2" @click="viewData.alignSelectedToRight()"><v-icon>mdi-align-horizontal-right</v-icon></v-btn>    
          <v-btn icon :disabled="selCount<2" @click="viewData.alignSelectedToStack()"><v-icon>mdi-format-align-justify</v-icon></v-btn>          
          <span class="sep">|</span>
          <v-btn icon :disabled="selCount<1" @click="viewData.selectedToFront()"><v-icon>mdi-arrange-bring-forward</v-icon></v-btn>    
          <v-btn icon :disabled="selCount<1" @click="viewData.selectedToBack()"><v-icon>mdi-arrange-send-backward</v-icon></v-btn>    
          <span class="sep">|</span>
          <v-btn icon><v-icon>mdi-dots-vertical</v-icon></v-btn>  
        </v-toolbar-items>  
      </transition>
      <!-- run mode toolbar -->
      <transition name="fadedly">
        <v-toolbar-items v-show="viewData.running">  
          <span class="spacer"></span>
          <v-text-field type="number" hide-details dense height="34" style="margin-top: 10px;" label="Write value" v-model="writeValue" v-on:keyup.13="writeValueClick"></v-text-field>
          <span class="errori">{{ errMsg }}</span>
          <v-btn @click="writeValueClick" icon><v-icon>mdi-keyboard-return</v-icon></v-btn>  
          <span class="sep">|</span>
        </v-toolbar-items>  
      </transition>
    </v-toolbar>
    <!-- other panels -->
    <div class="panes">
      <Split @onDragEnd="onSplitterMove" @onDrag="onSplitterMove">
        <SplitArea :size="editAreaSplitterPercent">
          <div id="box">
            <EditArea ref="editArea" id="editarea" @datachanged="dataChanged"></EditArea>
          </div>  
        </SplitArea>
        <SplitArea :size="propertyPanelSplitterSize">
          <PropertyPanel class="propertyeditor" :ItemData="itemData"></PropertyPanel>
        </SplitArea>
      </Split>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import EditArea from '@/components/EditArea.vue';
import PropertyPanel from '@/components/PropertyPanel.vue';
import { viewData } from '@/ViewData';

export default Vue.extend({
  data () {
    return {
      viewData: viewData,
      itemData: null,
      playIcon: "mdi-play-circle",
      editAreaSplitterPercent: 85,
      propertyPanelSplitterSize: 15,
      writeValue: "0",
      errMsg: ""
    }
  },

  computed: {
    selCount(): number {
      return viewData.numSelected();
    }
  },

  methods: {
    togglePlay(): void {
      this.viewData.running = !this.viewData.running;
      if (this.viewData.running) {
        this.playIcon = "mdi-stop-circle";
      }
      else {
        this.playIcon = "mdi-play-circle";
      }      
      (this.$refs.editArea as any).resize();  // tsc does not understand $refs, se we need this gludge
    },

    dataChanged(d): void {
      this.itemData = d;
    },

    // size: [%, %] (relative sizes)
    onSplitterMove(size: number): void {
      (this.$refs.editArea as any).resize();
    },

    // zoom command do not go via viewData, as they have nothing to do with it
    zoomIn(): void { 
       (this.$refs.editArea as any).zoomIn(); 
    },
    zoomOut(): void { 
       (this.$refs.editArea as any).zoomOut(); 
    },
    zoomReset(): void { 
       (this.$refs.editArea as any).zoomReset(); 
    },

    writeValueClick(): void {
      const v = parseFloat(this.writeValue);
      if (!isNaN(v)) {
        this.viewData.writeToSelected(v);
      }
      else {
        this.errMsg = `Error: can't convert to a number!`;
        setTimeout(() => { this.errMsg = ""}, 2000);
      }
    }
  },

  mounted (): void {
    console.log('EditView mounted');
      (this.$refs.editArea as any).resize();  // splitter changes sizes without any events...
      (this.$refs.tbtrans as any).addEventListener('transitioned', () => {
        console.log("trans done"); // not working
     });
  },

  components: { EditArea, PropertyPanel }
});
</script>

<style scoped>
.editview {
  height: 100%;
  width: 100%;
  /* disable user selection for toolbar area */  
  -ms-user-select: none; 
  -webkit-user-select: none; 
  user-select: none;
}
.panes {
  height: calc(100% - 48px);
}
#mainwin {
  height: calc(100%-48px);
}
#box { /* container for editarea and toolbox */
  padding: 0px;
  height: 100%;
  display: flex;
  flex-direction: column;
  overflow: hidden;
}
#toolbox {
  background-color: #272727;
  color: gray;
  border: none;
  padding: 0px;
  margin: 0px;
  height: 48px;
  width: 100%;
}
#editarea {
  display: inline-block;
  width: 100%;
  height: calc(100% - 48px); /* 1200px; */
  flex-grow: 1;
}
.errori {
  color: red;
  font-size: 20px;
  padding: 10px;
}
.propertyeditor {
  padding: 0px;
  float: right;
  top: 0px;
  /*
  width: 200px;
   height: 100%; */
}
.sep {
  color: lightgray;
  font-size: 30px;
}
.spacer {
  min-width: 10px;
}
.fadeup-enter-active, .fadeup-leave-active {
  transition: all .15s;  
}
.fadeup-enter, .fadeup-leave-to {
 transform: translateY(-50px);
 opacity: 0;
}
.fadedown-enter-active, .fadedown-leave-active {
  transition: all .15s;  
}
.fadedown-enter, .fadedown-leave-to {
 transform: translateY(50px);
 opacity: 0;
}
.fadedly-enter-active {
  transition: all 0.7s;  
}
.fadedly-leave-active {
  transition: all 0s;  
}
.fadedly-enter, .fadeup-leave-to {
 transform: translateY(-50px);
 opacity: 0;
}
</style>
